
#include "stdafx.h"
#include "XmlFileManager.h"

CXmlInternetFileManager::CXmlInternetFileManager()
{
	m_hInternetFile = m_hInternetSession = NULL;
}
CXmlInternetFileManager::~CXmlInternetFileManager()
{
	Close();
}

CXmlInternetFileManager& CXmlInternetFileManager::operator=(const CXmlInternetFileManager &obj)
{
	// prohibited use
	return *this;
}


// Methods
//

BOOL CXmlInternetFileManager::Open(char *szURL)
{
	strcpy(m_szURL, szURL);

	m_hInternetSession = InternetOpen("MSIE", INTERNET_OPEN_TYPE_PRECONFIG,
		NULL, NULL, 0);
	if (m_hInternetSession)
	{
		//We just download html and text. Modify if needs to download binary file.
		m_hInternetFile = InternetOpenUrl(m_hInternetSession, szURL,
			NULL, 0, INTERNET_FLAG_TRANSFER_ASCII | INTERNET_FLAG_RELOAD | INTERNET_FLAG_DONT_CACHE, 0);
	}
	if (!m_hInternetSession)
	{
		char szMessage[MAX_PATH];
		sprintf(szMessage,"Can't initialize Wininet layer");

		trace (TRC_ERROR,szMessage);

		setLastError( SAXML_ERROR_HTTPINIT );
		trace2(TRC_ERROR,"CXmlInternetFileManager::Open",SAXML_ERRORSTRING_HTTPINIT);

		return FALSE;
	}
	if (!m_hInternetFile)
	{
		char szMessage[MAX_PATH];
		sprintf(szMessage,"Can't open URL %s",szURL);

		trace (TRC_ERROR,szMessage);

		setLastError( SAXML_ERROR_BADURL );
		trace2(TRC_ERROR,"CXmlInternetFileManager::Open",SAXML_ERRORSTRING_BADURL);

		return FALSE;
	}

	return TRUE;
}

BOOL CXmlInternetFileManager::Read(char *szInputBuffer, int nMaxLength, int &nActualLength)
{
	if (!m_hInternetFile)
	{
		nActualLength = 0;

		setLastError( SAXML_ERROR_BADURL );
		trace2(TRC_ERROR,"CXmlInternetFileManager::Read",SAXML_ERRORSTRING_BADURL);

		return FALSE;
	}

	peekMessage();

	DWORD dwRead;

	InternetReadFile(m_hInternetFile, (LPVOID)szInputBuffer, nMaxLength-1, &dwRead);

	nActualLength = dwRead;
	szInputBuffer[nActualLength]='\0';

	return TRUE;
}

BOOL CXmlInternetFileManager::Close()
{
	if (m_hInternetFile) InternetCloseHandle(m_hInternetFile);
	if (m_hInternetSession) InternetCloseHandle(m_hInternetSession);

	m_hInternetFile = m_hInternetSession = NULL;

	return TRUE;
}
