
#include "stdafx.h"
#include "XmlFileManager.h"

CXmlLocalFileManager::CXmlLocalFileManager()
{
	fp = NULL;
}
CXmlLocalFileManager::~CXmlLocalFileManager()
{
	Close();
}


CXmlLocalFileManager& CXmlLocalFileManager::operator=(const CXmlLocalFileManager &obj)
{
	// prohibited use
	return *this;
}


// Methods
//

BOOL CXmlLocalFileManager::Open(char *szURL)
{
	strcpy(m_szURL, szURL);

	// open descriptor file
	//
	fp=fopen(szURL,"r"); // ASCII mode (EOL translated depending on platform)
	if (!fp)
	{
		char szMessage[SAXML_URLMAXLENGTH];
		sprintf(szMessage,"Can't open file %s",szURL);

		trace (TRC_ERROR,szMessage);

		setLastError( SAXML_ERROR_BADURL );
		trace2(TRC_ERROR,"CXmlLocalFileManager::Open",SAXML_ERRORSTRING_BADURL);

		return FALSE;
	}

	return TRUE;
}

BOOL CXmlLocalFileManager::Read(char *szInputBuffer, int nMaxLength, int &nActualLength)
{
	if (!fp)
	{
		setLastError( SAXML_ERROR_BADURL );
		trace2(TRC_ERROR,"CXmlLocalFileManager::Read",SAXML_ERRORSTRING_BADURL);

		return FALSE;
	}

	peekMessage();

	nActualLength = (int) fread(szInputBuffer, 1, nMaxLength, fp);

	return TRUE;
}

BOOL CXmlLocalFileManager::Close()
{
	if (fp)
	{
		fclose(fp);
		fp=NULL;
	}

	return TRUE;
}
