

#ifndef __SIMPLEXMLWRITER__
#define __SIMPLEXMLWRITER__

class CFile; // forward declaration

// xmlwriter

#define XMLTAG_XML					"xml"
#define XMLTAG_ROOT					"XmlAutomationBridge"


class XmlWriter
{
	// Members
	//
protected:
	CFile *m_pFile;
	BOOL m_bFileOpen, m_bPrototypeWritten;
	CString m_szFilename;
	int m_nLevel;

	// Constructor
public:
	XmlWriter();
	~XmlWriter();

	// Accessors
public:
	void SetIndentLevel(int n) { m_nLevel = n; }
	int GetIndentLevel() { return m_nLevel; }
	CString &GetFilename() { return m_szFilename; }

	BOOL MustBeClosed() { return m_bFileOpen; }

	// Methods
public:
	void Init();
	BOOL Open(CString &szFilename);
	BOOL WriteString(CString &szData);
	BOOL Close();
};

class XmlElement
{
	// Members
	//
protected:
	CString m_szName;
	CStringArray m_szAttribNames, m_szAttribValues;

	// Constructor
public:
	XmlElement();
	XmlElement(const CString &szName);

	// Accessors
public:
	void SetName(/*in*/const CString &szName);
	void GetName(/*out*/CString &szName);
	void GetAttribName(int nIndex, /*out*/ CString &szAttribName);
	void GetAttribValue(int nIndex, /*out*/ CString &szAttribValue);
	int GetAttribCount();
	BOOL FindAttrib(/*in*/CString &szAttribName);

	// Methods
	void AddAttrib(/*in*/CString &szName, /*in*/CString &szValue);

	void Write(XmlWriter &writer, int nDeltaLevel=0, BOOL bIndent=TRUE, BOOL bEOL=TRUE); // for any kind of open tag
	void WriteEmpty(XmlWriter &writer, int nDeltaLevel=0, BOOL bIndent=TRUE, BOOL bEOL=TRUE); // for any kind of open tag
	void WritePInstruction(XmlWriter &writer, int nDeltaLevel=0); // used mainly for <?xml ... ?>
	void WriteClosingTag(XmlWriter &writer, int nDeltaLevel=0, BOOL bIndent=TRUE, BOOL bEOL=TRUE); // for tag closure

};


#endif // __SIMPLEXMLWRITER__

